#include "s0012_integer_to_roman.hpp"

// 贪心哈希表
// 先硬编码一个哈希表
// 然后当数值大于一个值的时候，就直接把对应的字符串加上去

string S0012::intToRoman(int num) {
  int values[] = {1000, 900, 500, 400, 100, 90, 50, 40, 10, 9, 5, 4, 1};
  string reps[] = {"M",  "CM", "D",  "CD", "C",  "XC", "L",
                   "XL", "X",  "IX", "V",  "IV", "I"};
  string res;
  for (int i = 0; i < 13; i++) {
    while (num >= values[i]) {
      num -= values[i];
      res += reps[i];
    }
  }
  return res;
}
