#include "s0022_generate_parentheses.hpp"

#include <gtest/gtest.h>

TEST(Problem22, Case1) {
  int i{3};
  vector<string> o{"((()))", "(()())", "(())()", "()(())", "()()()"};
  S0022 solution;
  EXPECT_EQ(solution.generateParenthesis(i), o);
}

TEST(Problem22, Case2) {
  int i{1};
  vector<string> o{"()"};
  S0022 solution;
  EXPECT_EQ(solution.generateParenthesis(i), o);
}

TEST(Problem22, Case3) {
  int i{4};
  vector<string> o{"(((())))","((()()))","((())())","((()))()","(()(()))","(()()())","(()())()","(())(())","(())()()","()((()))","()(()())","()(())()","()()(())","()()()()"};
  S0022 solution;
  EXPECT_EQ(solution.generateParenthesis(i), o);
}
