#include "s0034_find_first_and_last_position_of_element_in_sorted_array.hpp"

#include <gtest/gtest.h>

TEST(Problem34, Case1) {
  vector<int> nums{5, 7, 7, 8, 8, 10};
  int target{8};
  vector<int> o{3, 4};
  S0034 solution;
  EXPECT_EQ(solution.searchRange1(nums, target), o);
  EXPECT_EQ(solution.searchRange2(nums, target), o);
}

TEST(Problem34, Case2) {
  vector<int> nums{5, 7, 7, 8, 8, 10};
  int target{6};
  vector<int> o{-1, -1};
  S0034 solution;
  EXPECT_EQ(solution.searchRange1(nums, target), o);
  EXPECT_EQ(solution.searchRange2(nums, target), o);
}

TEST(Problem34, Case3) {
  vector<int> nums{};
  int target{0};
  vector<int> o{-1, -1};
  S0034 solution;
  EXPECT_EQ(solution.searchRange1(nums, target), o);
  EXPECT_EQ(solution.searchRange2(nums, target), o);
}
