#ifndef S0037_SUDOKU_SOLVER_HPP
#define S0037_SUDOKU_SOLVER_HPP

#include <algorithm>
#include <cmath>
#include <unordered_map>
#include <vector>

using namespace std;

class S0037 {
 public:
  void solveSudoku(vector<vector<char>> &board);
  bool recusiveSolveSudoku(vector<vector<char>> &board,
                           vector<unordered_map<char, bool>> &rows,
                           vector<unordered_map<char, bool>> &cols,
                           vector<unordered_map<char, bool>> &grids, int row,
                           int col);
};

#endif
