#include "s0026_remove_duplicates_from_sorted_array.hpp"

int S0026::removeDuplicates(vector<int>& nums) {
  int size = nums.size();
  if (size == 0 || size == 1) {
    return size;
  }
  int slow{0};
  for (int fast{1}; fast < size; ++fast) {
    if (nums.at(fast) == nums.at(slow)) {
      continue;
    } else {
      nums[++slow] = nums.at(fast);
    }
  }
  return slow + 1;
}
