#include "s0006_zigzag_conversion.hpp"

#include <gtest/gtest.h>

TEST(Problem6, Case1) {
  string s("PAYPALISHIRING");
  int rows = 3;
  string r("PAHNAPLSIIGYIR");
  S0006 solution;
  EXPECT_TRUE(solution.convert(s, rows) == r);
}

TEST(Problem6, Case2) {
  string s("PAYPALISHIRING");
  int rows = 4;
  string r("PINALSIGYAHRPI");
  S0006 solution;
  EXPECT_TRUE(solution.convert(s, rows) == r);
}

TEST(Problem6, Case3) {
  string s("AB");
  int rows = 4;
  string r("AB");
  S0006 solution;
  EXPECT_TRUE(solution.convert(s, rows) == r);
}
